#/bin/bash
#
# All Rights Reserved, Copyright (c) FUJITSU LIMITED 2012-2014
#
#	Configuration Tool for Oracle VM Server for SPARC
#
# Revision 2.2  2014/10/02
#
# custom_service.sh

service_custom()
{
#---set default------------------------------------------------------------#
TITLE=" 3. Configure an I/O domain or Service Domain"
DKIND="I/O"
PATTERN="Original"
#work_out="${work_dir}/${DOMAIN}"

#--------------------------------------------------------------------------#
#mkdir $work_out > /dev/null 2>&1

############################################################################
# Specify Domain Name   
############################################################################

header "$TITLE" "$PATTERN"
print "# Select I/O domain                                              "
print ""
print "Add a service domain function to an I/O domain."
print ""
print "t:top menu  q:quit"
print "---------------------------------------------------------------------------------------"
print ""

while :
do
	echo "The following I/O domains exist:"
	i=1
	for j in `cat $work_dir/service_domain_list`
	do
		echo " $i. $j"
		i=`expr $i + 1`
	done
	echo "Select the domain for which you wish to add a service domain function. ==> \c"
	read NUM
	case $NUM in
		[t])	top
			;;
		[q])	quit
			;;
		[0])	echo "ERROR: Invalid input value."
			echo ""
			;;
		  *)	expr $NUM + 1 > /dev/null 2>&1
			if [ $? != 0 ];then
				echo "ERROR: Invalid input value."
				echo ""
			else
				if [ "${NUM:-999}" -lt "$i" ];then
					break
				else
					echo "ERROR: Invalid input value."
					echo ""
				fi 
			fi
			;;
	esac
done

DOMAIN=`echo $DOMAIN_LIST | awk '{print $'$NUM'}'`
work_out="${work_dir}/${DOMAIN}"
mkdir $work_out > /dev/null 2>&1
echo "Domain : $DOMAIN" >> $work_out/dom.info 

############################################################################
# Setting Service Domain
############################################################################

header "$TITLE" "$PATTERN"
print "# Confirm the specified I/O domain"
print ""
printf "A service domain function will be added to the %s domain.\n" "$DOMAIN"
print ""
print "t:top menu  q:quit"
print "---------------------------------------------------------------------------------------"
print ""

while :
do
	YN=""
	echo "Are you sure? (y/n) ==> \c"
	read YN
	case $YN in
	  [t])	top
		continue
		;;
	  [q])	quit
		continue
		;;
	  [y])	############################################################
		# Creating VDS
		############################################################
		header "$TITLE" "$PATTERN"
		print "# Virtual disk server                                                            [1/4]"
		print ""
		print "Do you wish to create a virtual disk server (vds) to allow importing virtual disks"
		print "into a domain?"
		print ""
		print "t:top menu  q:quit"
		print "---------------------------------------------------------------------------------------"
		print ""

		while :
		do
			YN_VDS=""
			echo "Create a virtual disk server (vds)? ([y]/n) ==> \c"
			read YN_VDS
			case ${YN_VDS:-y} in
			  [t])	top
				;;
			  [q])	quit
				;;
			  [y])	while :
				do
					echo "Enter the desired quantity of virtual disk servers. [1] ==> \c"
					read NUM_of_VDS
					expr ${NUM_of_VDS:-1} + 1 > /dev/null 2>&1
					if [ $? = 0 ];then
						break
					else
						if [ ${NUM_of_VDS:-1} = t ];then
							top
							continue
						elif [ ${NUM_of_VDS:-1} = q ];then
							quit
							continue
						else
							echo "ERROR: Invalid input value."
						fi
					fi
				done

				echo ""
				if [ ${NUM_of_VDS:-1} -gt 0 ];then
					echo "=== These vds settings will be created ==="
				fi
					
				COUNT1=0
				while [ $COUNT1 -lt ${NUM_of_VDS:-1} ]
				do
					COUNT2=`expr $COUNT1 + 1`
					echo "VDS    : Add $DOMAIN-vds$COUNT1 to the $DOMAIN domain." | tee -a $work_out/vds.tmp
					COUNT1=`expr $COUNT1 + 1`
				done
				break
				;;
			  [n])	break
				;;
			    *)	continue
				;;
			esac
		done

		if [ ${NUM_of_VDS:-1} -eq 0 -o ${YN_VDS:-y} = n ];then
			echo ""
			echo "A virtual disk server will not be created."
		fi

		echo "---------------------------------------------------------------------------------------"
		echo "Please press the enter key."
		read key

		############################################################
		# Creating VCC
		############################################################
		header "$TITLE" "$PATTERN"
		print "# Virtual Console Concentrator                                                   [2/4]"
		print ""
		print "Create a virtual console concentrator (vcc) service for use by the virtual network" 
		print "terminal server daemon (vntsd) and as a concentrator for all domain consoles."
		print ""
		print "t:top menu  q:quit"
		print "---------------------------------------------------------------------------------------"
		print ""
		
		while :
		do
			YN_VCC=""
			echo "Create a virtual console concentrator (vcc)? ([y]/n) ==> \c"
			read YN_VCC
			case ${YN_VCC:-y} in
			  [t])	top
				continue
				;;
			  [q])	quit
				continue
				;;
			  [y])	echo "Enter the range of port numbers for $DOMAIN-vcc0."
				while :
				do
					echo " starting port number [5000] ==> \c"
					read STPORT
					case ${STPORT:-5000} in
					  [t])	top
						continue
						;;
					  [q])	quit
						continue
						;;
					    *)	expr ${STPORT:-5000} + 1 > /dev/null 2>&1
						if [ $? = 0 ];then
							if [ ${STPORT:-5000} -ge 1024 -a ${STPORT:-5000} -le 65535 ];then
								break
							else
								echo "ERROR: Invalid input value."
								echo "ERROR: Please enter a number between 1024 and 65535."
								continue
							fi
						else
							echo "ERROR: Invalid input value."
							continue
						fi
						;;
					esac
				done

				while :
				do
					DEF_EDPORT=`expr ${STPORT:-5000} + 100`
					if [ $DEF_EDPORT -ge 65535 ];then
						DEF_EDPORT=65535
					fi

					echo " ending port number [$DEF_EDPORT] ==> \c"
					read EDPORT
					case ${EDPORT:-$DEF_EDPORT} in
					  [t])	top
						continue
						;;
					  [q])	quit
						continue
						;;
					    *)	expr ${EDPORT:-$DEF_EDPORT} + 1 > /dev/null 2>&1
						if [ $? = 0 ];then
							if [ ${EDPORT:-$DEF_EDPORT} -ge ${STPORT:-5000} -a ${EDPORT:-$DEF_EDPORT} -le 65535 ];then
								break
							else
								echo "ERROR: Invalid input value."
								echo "ERROR: Please enter a number between ${STPORT:-5000} and 65535."
								echo ""
								continue
							fi
						else
							echo "ERROR: Invalid input value."
							continue
						fi
						;;
					esac
				done

				echo "VCC    : $DOMAIN-vcc0 will use the port range of ${STPORT:-5000} to ${EDPORT:-$DEF_EDPORT}" >> $work_out/vcc.tmp
				break
				;;
			  [n])	break
				;;
			esac
		done

		echo ""
		if [ -f $work_out/vcc.tmp ];then
			echo "=== The following vcc setting will be made ==="
			cat $work_out/vcc.tmp
			echo ""
			echo "---------------------------------------------------------------------------------------"
			echo "After installing the OS on the I/O domain, please enable the vntsd service on the I/O"
			echo "domain using the following command."
			echo "Command: svcadm enable svc:/ldoms/vntsd:default"
		else
			echo "Virtual console concentrator is not created."
		fi	

		echo "---------------------------------------------------------------------------------------"
		echo "Please press the enter key."
		read key

		############################################################
		# Creating VSW
		############################################################
		header "$TITLE" "$PATTERN"
		print "# Virtual switch                                                                 [3/4]"
		print ""
		print "Do you wish to create a virtual switch service (vsw) to enable networking between the"
		print "virtual network (vnet) devices in logical domains?"
		print ""
		print "t:top menu  q:quit"
		print "---------------------------------------------------------------------------------------"
		print ""

		while :
		do
			YN_VSW=""
			echo "Create a virtual switch service? ([y]/n) ==> \c"
			read YN_VSW
			case ${YN_VSW:-y} in
			  [t])	top
				continue
				;;
			  [q])	quit
				continue
				;;
			  [y])	while :
				do
					echo "Enter the quantity of virtual switch service [1] ==> \c"
					read NUM_of_SW
					expr ${NUM_of_SW:-1} + 1 > /dev/null 2>&1
					if [ $? = 0 ];then
						if [ ${NUM_of_SW:-1} = t ];then
							top
						elif [ ${NUM_of_SW:-1} = q ];then
							quit
						else
							#ver1.1
							if [ ${NUM_of_SW:-1} -le 768 ];then
								break
							else
								echo "ERROR: Invalid input value."
							fi
						fi
					else
						echo "ERROR: Invalid input value."
					fi
				done

				COUNT03=0
				while [ $COUNT03 -lt ${NUM_of_SW:-1} ]
				do
					echo ""
					COUNT04=`expr $COUNT03 + 1`
					case $COUNT04 in
					  [1])	echo "=== Set the 1st virtual switch service configuration ==="
						;;
					  [2])	echo "=== Set the 2nd virtual switch service configuration ==="
						;;
					  [3])	echo "=== Set the 3rd virtual switch service configuration ==="
						;;
					[4-9])	echo "=== Set the ${COUNT04}th virtual switch service configuration ==="
						;;
					    *)	echo "=== Set the next virtual switch service configuration ==="
						;;
					esac 
					echo "This virtual switch service is named $DOMAIN-vsw$COUNT03."
					echo "Allocate a physical NIC, such as net0, for $DOMAIN-vsw$COUNT03."
					echo "Please input \"none\" when do not wish to allocate a NIC."
					echo "Input a NIC for $DOMAIN-vsw$COUNT03. (netX or [none]) ==> \c"
				        read PNIC

					if [ ${PNIC:-"none"} = "none" ];then
						echo "VSW    : $DOMAIN-vsw$COUNT03 : No physical NIC assigned." >> $work_out/vsw.tmp
					else
						echo "VSW    : $DOMAIN-vsw$COUNT03 : $PNIC was allocated." >> $work_out/vsw.tmp
					fi
				        COUNT03=`expr $COUNT03 + 1`
				done
				break
				;;
			  [n])	break
				;;
			    *)	continue
				;;
			esac
		done

		if [ ${NUM_of_SW:-1} -eq 0 ];then
			echo ""
			echo "A virtual switch service will not be created."
		else
			if [ -f $work_out/vsw.tmp ];then
				echo ""
				echo "=== These virtual switch service settings will be made ==="
				cat $work_out/vsw.tmp
			else
				echo ""
				echo "A virtual switch service will not be created."
			fi
		fi
		echo "---------------------------------------------------------------------------------------"
		echo "Please press the enter key."
		read key

		############################################################
		# Service configutatin check
		############################################################

		if [ "$YN_VDS" = "n" -a "$YN_VCC" = "n" -a "$YN_VSW" = "n" ];then
			echo "---------------------------------------------------------------------------------------"
			echo "A service domain function will not be added to the  domain."
			echo "The operation was aborted, and the domain configuration information was not saved."
			echo "---------------------------------------------------------------------------------------"
			echo "Please press the enter key."
			read key
			delete
			exit 0
		fi

		############################################################
		# Setting configuratin or Update configuration
		############################################################

		#---get current config-----------------------------------------------------#

		print_config()
		{
		echo "Config name timestamp" | awk '{printf"%-1s%-7s%-44s%-10s\n"," ",$1,$2,$3}'
		echo "-------------------------------------------------- ------------" | awk '{printf"%-1s%-51s%-13s\n"," ",$1,$2}'

		ldm list-config >> $work_dir/list-config.tmp

		for i in `ls -t /var/opt/SUNWldm | grep autosave | sed -e s/autosave-//`
		do
			LANG=C
			A=`cat $work_dir/list-config.tmp | grep -w $i`
			if [ "$A" != "" ];then
				ls -lt /var/opt/SUNWldm | grep -w "autosave-$i" | sed -e s/autosave-// | awk '{printf"%-1s%-51s%-4s%-3s%-6s\n"," ",C,$6,$7,$8}' C="$A"
			fi
		done

		}
#		status=`print_config`

		CUR_CONF=`ls -t /var/opt/SUNWldm | grep autosave | sed -e s/autosave-// | sed -n 1p`

		#--------------------------------------------------------------------------#

		header "$TITLE" "$PATTERN"
		print "# Save configuration                                                             [4/4]"
		print ""
		print "Save the new logical domain configuration to the service processor (XSCF) with the"
		print "current file name or with a new filename."
		print "Overwriting existing files that are not marked \"current\" below is not allowed."
		print ""
		print_config
		print ""
		print "t:top menu  q:quit"
		print "---------------------------------------------------------------------------------------"
		print ""

		CUR_CHECK=`echo "$CUR_CONF" | cut -c1`
		if [ "$CUR_CHECK" = "_" ];then
			while :
			do
				echo "Please enter the new configuration file name." 
				echo "Enter the new configuration file name. ==> \c"
				read NEW_CONF
				case ${NEW_CONF:-""} in
				  [t])	top
					continue
					;;
				  [q])	quit
					continue
					;;
				    *)	if [ ${NEW_CONF:-" "} = " " ];then
						echo "ERROR: Invalid input value."
						echo ""
						continue
					else
						grep -w ${NEW_CONF:-""} $work_dir/list-config.tmp > /dev/null 2>&1
						if [ $? = 0 ];then
							echo "ERROR: Configuration file named $NEW_CONF already exists."
							echo ""
							continue
						else
							echo "The configuration name : $NEW_CONF (new file)" >> $work_out/config.tmp		
						fi
						break
					fi
					;;
				esac
			done
		else
			while :
			do
				echo "Please select the method for saving the new logical domain configuration."
				echo " 1. Save as the current configuration file name ($CUR_CONF)."
				echo " 2. Save as a new configuration file."
				echo "Enter a number [1] ==> \c"
				read NUM

				case ${NUM:-1} in
				  [t])	top
					continue
					;;
				  [q])	quit
					continue
					;;
				  [1])	echo "The configuration name : $CUR_CONF" >> $work_out/config.tmp
					break
					;;
				  [2])	while :
					do
						echo "Enter the new configuration file name. ==> \c"
						read NEW_CONF
						case ${NEW_CONF:-""} in
						  [t])	top
							continue
							;;
						  [q])	quit
							continue
							;;
						    *)	if [ ${NEW_CONF:-" "} = " " ];then
								echo "ERROR: Invalid input value."
								echo ""
								continue
							else
								grep -w ${NEW_CONF:-""} $work_dir/list-config.tmp > /dev/null 2>&1
								if [ $? = 0 ];then
									echo "ERROR: Configuration file named ${NEW_CONF:-""} already exists."
									echo ""
									break
								else
									echo "The configuration name : $NEW_CONF (new file)" >> $work_out/config.tmp
								fi
								break 2
							fi
							;;
						esac
					done
					;;
				    *)	echo "ERROR: Invalid input value."
					echo ""
					continue
					;;
				esac
			done
		fi
		#ver1.1

		echo ""
		echo "=== The configuration will be saved ==="
		cat $work_out/config.tmp
		echo "---------------------------------------------------------------------------------------"
		echo "Please press the enter key."
		read key

		break
		;;
	  [n])	rm $work_out/dom.info
		service_custom
		;;
	    *)	echo "Please select y(yes) or n(no)."
		;;
	esac
done

############################################################################
# Confirmation of setting
############################################################################

header "$TITLE" "$PATTERN"
print "The following I/O domain configuration will be set."
print ""

print "======= Your configuration information for service domain $DOMAIN ====================="
#if [ -f $work_out/dom.info ];then cat $work_out/dom.info ;fi
if [ -f $work_out/vds.tmp ];then cat $work_out/vds.tmp ;fi
if [ -f $work_out/vcc.tmp ];then cat $work_out/vcc.tmp ;fi
if [ -f $work_out/vsw.tmp ];then cat $work_out/vsw.tmp ;fi
print "-------------------------------------------------------------------"
if [ -f $work_out/config.tmp ];then cat $work_out/config.tmp ;fi
print "======================================================================================="
print ""

############################################################################
# Execution and creating of configuration file
############################################################################

EXE=$conf_dir/${DOMAIN}-service-${DATE}.sh

save_exec 0

############################################################################
# Delete temporary file 
############################################################################

delete
############################################################################

}
