#/bin/bash
#
# All Rights Reserved, Copyright (c) FUJITSU LIMITED 2012-2014
#
#	Configuration Tool for Oracle VM Server for SPARC
#
# Revision 2.2  2014/10/02
#
# pattern4_io2.sh

io_pattern42()
{

#---set default------------------------------------------------------------#
DOMAIN="iodom0"
VDS="io-vds-web io-vds-ap"
PVSW="net2,io-vsw-pub0 net6,io-vsw-pub1"
LVSW="io-vsw-local0 io-vsw-local1"

#--------------------------------------------------------------------------#
TITLE=" 3.Configure a I/O Domain#0"
DKIND="I/O"
PATTERN="Pattern 4"
work_out="${work_dir}/${DOMAIN}"

#--------------------------------------------------------------------------#
mkdir $work_out > /dev/null 2>&1

############################################################################
# Creating VDS
############################################################################

header "$TITLE" "$PATTERN"
print "# Virtual disk server                                                            [1/3]"
print ""
print "A virtual disk server (vds) is created to allow importing virtual disks."
print ""
print "t:top menu  q:quit"
print "---------------------------------------------------------------------------------------"
print ""

for i in $VDS
do
	echo "VDS    : Add $i to the $DOMAIN domain." >> $work_out/vds.tmp
done

echo "=== The following logical domain name will be set ==="
cat $work_out/vds.tmp
echo "---------------------------------------------------------------------------------------"
echo "Please press the enter key."
read key


############################################################################
# Creating VSW
############################################################################

header "$TITLE" "$PATTERN"
print "# Virtual switch                                                                 [2/3]"
print ""
print "A virtual switch service (vsw) is created."
print ""
print "t:top menu  q:quit"
print "---------------------------------------------------------------------------------------"
print ""

for i in $PVSW
do
	PNIC=`echo $i|awk -F","  '{print $1}'`
	PNAM=`echo $i|awk -F","  '{print $2}'`
	echo "VSW    : $PNAM : $PNIC was allocated." >> $work_out/vsw.tmp
done

for i in $LVSW
do
	echo "VSW    : $i : No physical NIC assigned." >> $work_out/vsw.tmp
done

echo "=== The following logical domain name will be set ==="
cat $work_out/vsw.tmp
echo "---------------------------------------------------------------------------------------"
echo "Please press the enter key."
read key

############################################################################
# Check configuration file name
############################################################################

header "$TITLE" "$PATTERN"
print "# Save configuration                                                             [3/3]"
print ""
print "Save the configuration to a file, and proceed to add a logical domain machine"
print "configuration to the service processor(XSCF)."
print ""
print "t:top menu  q:quit"
print "---------------------------------------------------------------------------------------"
print ""

LDM_CONF=`ldm ls-config|grep current|awk -F" " '{print $1}'`
if [ "$LDM_CONF" = "" ];then
	LDM_CONF=`ldm ls-config | grep ] |awk -F" " '{print $1}'`
fi

while :
do
	echo "Enter the configuration filename. [$LDM_CONF] ==> \c"
	read ICONF
	case ${ICONF:-$LDM_CONF} in
		[t])	top
			;;
		[q])	quit
			;;
		*) echo ""
			if [ ${ICONF:-$LDM_CONF} != $LDM_CONF ];then
				CONF_O=${ICONF:-$LDM_CONF}
				config_name $CONF_O
			else
				CONFIG=${ICONF:-$LDM_CONF}
			fi
			break;
			;;
	esac
done

echo ""
echo "=== The configuration will be saved as the following ==="
ldm list-config | grep -w $CONFIG > /dev/null 2>&1
if [ $? = 0 ];then
	echo "The configuration name : $CONFIG" | tee -a $work_out/config.tmp
else
	echo "The configuration name : $CONFIG (new file)" | tee -a $work_out/config.tmp
fi
echo "---------------------------------------------------------------------------------------"
echo "Please press the enter key."
read key

############################################################################
# Confirmation of setting
############################################################################

header "$TITLE" "$PATTERN"
print "The following I/O domain configuration will be set."
print ""

printf "======= Your configuration information for I/O domain %s =========================\n" "$DOMAIN"
cat $work_out/vds.tmp
print "-------------------------------------------------------------------"
cat $work_out/vsw.tmp
print "-------------------------------------------------------------------"
cat $work_out/config.tmp
print "======================================================================================="
print ""

############################################################################
# Execution and creating of configuration file
############################################################################

EXE=$conf_dir/${DOMAIN}-${DATE}.sh

save_exec 0

############################################################################
# Delete temporary file 
############################################################################

delete
############################################################################

}
